#
# modifichiamo la pila in modo da poter eseguire una ireqt che porti il
# processore a livello utente.  Vogliamo tornare comunque al chiamante e senza
# passare ad una nuova pila, quindi effettuiamo la seguente trasformazione:
#
#                    +---------+
#                    |   rit   |
#                    +---------+
#                    | cs usr  |
#                    +---------+
#              ==>   | rflags  |
#                    +---------+
#                    |  rsp .-----+
#  +--------+        +---------+  |
#  |  rit   |        | ss usr  |  |
#  +--------+        +---------+  |
#                               <-+
#
.global liv_utente
liv_utente:
	popq %rax	# rit
	movq %rsp, %rdi
	pushq $0x1b	# selettore dati utente (ss usr)
	pushq %rdi	# rsp salvato in precedenza
	pushq $0x0200	# rflags con IF=1 e IOPL=sistema
			# provare anche con
			# $0x3200 (IF=1 e IOPL=utente)
	pushq $0x13	# selettore codice utente (cs usr)
	pushq %rax	# rit salvato in precedenza
	iretq

# per tornare a livello sistema modifichiamo le informazioni salvate in pila
# dalla int 0x70 in modo che 'cs' sia quello sistema (0x8) e non quello utente
# (0x13). A questo punto eseguiamo iretq. Questo non causerà eccezioni di
# protezione perché il ritorno da livello sistema a livello sistema è ammesso.
.global liv_sistema
liv_sistema:
	movq $0x8, 8(%rsp)
	movq $0, 32(%rsp)
	iretq

.data
.balign 16
.global sys_tss, sys_tss_end
sys_tss:
	.fill 1, 4, 0
	.quad sys_stack_end
	.fill 11, 8, 0
	.fill 1, 2, 0
        .word sys_tss_end - sys_tss
sys_tss_end:

.bss
sys_stack:
	.space 4096, 0
sys_stack_end:
